> [!NOTE]
> **Note:** Requires [authorization](https://developers.google.com/android/work/play/emm-api/v1/products/generateApprovalUrl#auth).

<br />

**Deprecated:** New integrations cannot use this method and can refer to our [new
recommendations](https://developers.google.com/android/work/deprecations#recommended_alternative).  
**This method will no longer be accessible by
anyone after September 30, 2025.** Generates a URL that can be rendered in an iframe to display the permissions (if any) of a product. An enterprise admin must view these permissions and accept them on behalf of their organization in order to approve that product.   

Admins should accept the displayed permissions by interacting with a separate UI element in the EMM console, which in turn should trigger the use of this URL as the `approvalUrlInfo.approvalUrl` property in a `Products.approve` call to approve the product. This URL can only be used to display permissions for up to 1 day.

<br />

## Request

### HTTP request

```
POST https://www.googleapis.com/androidenterprise/v1/enterprises/enterpriseId/products/productId/generateApprovalUrl
```

### Parameters

| Parameter name | Value | Description |
|---|---|---|
| **Path parameters** |||
| `enterpriseId` | `string` | The ID of the enterprise. |
| `productId` | `string` | The ID of the product. |
| **Optional query parameters** |||
| `languageCode` | `string` | The BCP 47 language code used for permission names and descriptions in the returned iframe, for instance "en-US". |

### Authorization

This request requires authorization with the following scope:

| Scope |
|---|
| `https://www.googleapis.com/auth/androidenterprise` |

For more information, see the [authentication and authorization](https://developers.google.com/android/work/play/emm-api/v1/how-tos/authorizing) page.

### Request body

Do not supply a request body with this method.

## Response

If successful, this method returns a response body with the following structure:

```
{
  "url": string
}
```

| Property name | Value | Description | Notes |
|---|---|---|---|
| `url` | `string` | A URL that can be rendered in an iframe to display the permissions (if any) of a product. This URL can be used to approve the product only once and only within 24 hours of being generated, using the `Products.approve` call. If the product is currently unapproved and has no permissions, this URL will point to an empty page. If the product is currently approved, a URL will only be generated if that product has added permissions since it was last approved, and the URL will only display those new permissions that have not yet been accepted. |   |